//
// myremocon.c
//
// R
// 
// Written by Nobuki HIRAMINE
// Last modified : 2016/05/05
//
#include <wiringPi.h>
#include <stdio.h>	// for fprintf()
#include <stdlib.h>	// for atoi()
#include <string.h>	// for strtok()
#include "myremocon.h"	// for MAX_BUTTON

// printfLɂ邩
#define ENABLE_PRINT
#ifdef  ENABLE_PRINT
	#define myprintf(fmt, args...)	printf(fmt, ## args)
#else
	#define myprintf(fmt, args...)
#endif

// 萔
int		PIN_IRSENSOR;	// ԊOZT[̃sԍ
int*	PIN_BUTTONS;	// {^̃sԍ
int		COUNT_BUTTON;	// {^̌
int		PIN_STATELED;	// ԕ\pLED̃sԍ

#define MICROS_LEARNINGTIMEOUT	(32000)		// wK^CAEgԁB32000}CNb=0.032biShort^̏32767ɐݒj
#define MILLIS_MODETIMEOUT 		(10000)		// [h^CAEgԁB10000~b=10b
#define MILLIS_DEBOUNCEDELAY 	(500)		// foEXԁB500~b=0.5b
#define STRING_FILENAME			("highlow_ch%d.txt")	// wKHighLowԂۑt@C
#define MAX_HIGHLOW				(1024)		// HighLowԂ̍ő
#define MILLIS_BLINKINTERVAL	(500)		// LED_ł̊Ԋu

// ^`
enum EMODE	// [h񋓌^
{
	MODE_GENERAL = 0,	// ʏ탂[h
	MODE_LEARNING,		// wK[h
	MODE_STORING,		// L[h
};

// O[oϐiړug_vj
enum EMODE		g_eMode = MODE_GENERAL;
unsigned int	g_uiMillis_ModeChanged = 0;		// [hύXi[h^CAEgpj
int 			g_aiState_Button_prev[MAX_BUTTON];	// {^̑ȌԁifoEXpj
unsigned int	g_auiMillis_Button_prev[MAX_BUTTON];	// {^̏ԂuOFFONvO̎ifoEXpj
int 			g_iCountHighLow = 0;			// wKHighLowԂ̌
short 			g_ashMicrosHighLow[MAX_HIGHLOW];	// wKHighLowԂ̔z
int				g_iStored;						// LꂽǂB

// wKHighLowԂ̕ۑ
int SaveHighLowArray( 	char* pszFileName,		// [in] t@C
						int iCountHighLow,		// [in] HighLowԂ̌
						short* ashMicrosHighLow )	// [in] HighLowԂ̔z
{
	// Cvbg`FbN
	if( NULL == pszFileName
	 || 0 == iCountHighLow
	 || NULL == ashMicrosHighLow )
	{
		return 0;
	}

	// t@CI[v
	FILE* pFile = fopen( pszFileName, "wt" );
	if( NULL == pFile )
	{
		return 0;
	}
	
	int iIndexHighLow;
	for( iIndexHighLow = 0; iIndexHighLow < iCountHighLow; iIndexHighLow++ )
	{
		fprintf( pFile, "%d,", ashMicrosHighLow[iIndexHighLow] );
	}
	
	// t@CN[Y
	fclose( pFile );
	
	return 1;
}

// wKHighLowԂ̓ǂݍ
int LoadHighLowArray( 	char* pszFileName,		// [in] t@C
						int* piCountHighLow,	// [in/out] ԃobt@[TCÝBǂݍ݌ʂ̎Ԃ̌o͂B
						short* ashMicrosHighLow )	// [in/out] ԃobt@[͂Aǂݍ݌ʂ̎Ԃobt@[o͂B
{
	// Cvbg`FbN
	if( NULL == pszFileName
	 || NULL == piCountHighLow
	 || NULL == ashMicrosHighLow )
	{
		return 0;
	}

	// t@CI[v
	FILE* pFile = fopen( pszFileName, "rt" );
	if( NULL == pFile )
	{
		return 0;
	}
	
	// 1s̓̕ǂݍ
	char szReadBuffer[1024 * 6];	// 6 : l5,J}
	if( NULL == fgets( szReadBuffer, 1024 * 6, pFile ) )
	{
		fclose( pFile );
		goto LABEL_FAILED;
	}
	// t@CN[Y
	fclose( pFile );
	
	// ǂݍ񂾕g[Nɕ
	int iIndexHighLow = 0;
	char* pszToken = strtok( szReadBuffer, "," );
	while( pszToken )
	{
		if( iIndexHighLow >= *piCountHighLow )
		{	// obt@[TCYz
			goto LABEL_FAILED;
		}
		ashMicrosHighLow[iIndexHighLow] = atoi( pszToken );	// o͕ϐւ̑
		iIndexHighLow++;
		pszToken = strtok( NULL, "," );
	}
	
	// 
	*piCountHighLow = iIndexHighLow;	// ǂݍ݌ʂ̎Ԃ̌o
	return 1;

LABEL_FAILED:
	// s
	*piCountHighLow = 0;	// ǂݍ݌ʂ̎Ԃ̌o
	return 0;
}

// wKHighLowԂ̑M
int SendHighLowArray( int iPinIRLED, int iCountHighLow, short* ashMicrosHighLow )
{
	// Cvbg`FbN
	if( 0 == iCountHighLow
	 || NULL == ashMicrosHighLow )
	{
		return 0;
	}

	// sݒ
	pinMode( iPinIRLED, OUTPUT );

	// o̓s̏
	digitalWrite( iPinIRLED, LOW );

	int iIndexHighLow;
	for( iIndexHighLow = 0; iIndexHighLow < iCountHighLow; iIndexHighLow++ )
	{
		int          iMicros_length = ashMicrosHighLow[iIndexHighLow];
		unsigned int uiMicors_start = micros();
		do
		{
			// g38kHzOn/Off悤ɂQdelayMicroseconds̎Ԃ𒲐B
			// 38kHz => 26.3[}CNb]/B
			// RM͏d͂}邽߂Ƀf[eB[P΂Q̃pXóB
			// HIGHo͂́AHIGH9[}CNb]ALOW17[}CNb]JԂo͂܂B
			digitalWrite( iPinIRLED, 1 - (iIndexHighLow % 2) );	// iIndexHighLow : 0́AhighB 1́AlowBȉlB
			delayMicroseconds(9);
			digitalWrite( iPinIRLED, 0 );
			delayMicroseconds(17);
		} while( iMicros_length > micros() - uiMicors_start );
	}
	
	// o̓š㏈
	digitalWrite( iPinIRLED, LOW );
	
	return 1;
}

// wK[h
void loopSub_Learning(void)
{
	static int s_iState_prev = HIGH;			// ԊOZT[̑O̒l
	static unsigned int s_uiMicros_prev = 0;	// ԊOZT[̒lωO̎

	digitalWrite(PIN_STATELED, HIGH);	// ԕ\pLED : _

	int iState = digitalRead(PIN_IRSENSOR); // ZT[lǂݎ
	
	// ZT[lωǂ
	if( iState != s_iState_prev )
	{
		// OZT[lωԂ̌oߎԂZo
		unsigned int uiMicros = micros();
		if( 0 == s_uiMicros_prev )
		{	// wK1ڂ̃ZTlώAuLOWvˁuHIGHvB
			// HighLowJE^[Zbg
			g_iCountHighLow = 0;
		}
		else
		{	// LowԂHigh
			short shMicros_diff = (short)(uiMicros - s_uiMicros_prev);
			g_ashMicrosHighLow[g_iCountHighLow] = shMicros_diff;
			g_iCountHighLow++;
			myprintf( "%d,", shMicros_diff );
		}
		s_uiMicros_prev = uiMicros;
		s_iState_prev = iState;
		return;	// ZT[lω̏ς݁Ã[v̏IB
	}
	
	// ZT[l͕ωĂȂ
	if( s_uiMicros_prev )
	{	// wKis_uiMicros_prev[ȊOj
		// ZT[lω̂Ȃ̎Ԃ^CAEgbo߂wKIB
		if( MICROS_LEARNINGTIMEOUT < (micros() - s_uiMicros_prev) )
		{	// wK^CAEg
			// wK^CAEǵuԂHIGHvԂłA
			// wKʂƂẮALowԁAHighԁALowԁAAALow
			// ƁAHighLowԂ̌͊ԁB
			if( 0 == g_iCountHighLow % 2 )
			{	// HighLowԂ̌Ȃ̂ŁAwKs
				myprintf( "\nFailed    : Learning\n" );
			}
			else
			{	// HighLowԂ̌Ȃ̂ŁAwK
				// ŌLowԂǉB
				g_ashMicrosHighLow[g_iCountHighLow] = MICROS_LEARNINGTIMEOUT;
				g_iCountHighLow++;
				myprintf( "%d, ", MICROS_LEARNINGTIMEOUT );
				myprintf( "\nSucceeded : Learning\n" );
			}
			s_uiMicros_prev = 0;
			myprintf( "Change Mode : StoringMode\n" );
			g_eMode = MODE_STORING;	// L[hɈڍs
			g_uiMillis_ModeChanged = millis();	// [hύX̕ێ
			return;	// [hύX̂ŁÃ[v̏IB
		}
	}
	else
	{	// wKłȂ
		// ZT[lω̂ȂԂ^CAEgbo߂ʏ탂[hɖ߂
		unsigned int uiMillis = millis();
		if( MILLIS_MODETIMEOUT < (uiMillis - g_uiMillis_ModeChanged) )
		{	// [h^CAEg
			myprintf( "TimeOut     : LearningMode\n" );
			s_uiMicros_prev = 0;
			myprintf( "Change Mode : GeneralMode\n" );
			g_eMode = MODE_GENERAL;	// ʏ탂[hɈڍs
			g_uiMillis_ModeChanged = uiMillis;	// [hύX̕ێ
			return;	// [hύX̂ŁÃ[v̏IB
		}
	}
}

// L[h
void loopSub_Storing(void)
{
	static unsigned int	s_uiMillis_blinkturn_prev = 0;	// ԕ\pLED̓_ŏO̎
	static int			s_iBlink_current = LOW;			// ԕ\pLED̓_ł݂̌̏

	unsigned int uiMillis = millis();

	if( MILLIS_BLINKINTERVAL < (uiMillis - s_uiMillis_blinkturn_prev) )
	{
		s_iBlink_current = !s_iBlink_current;
		digitalWrite(PIN_STATELED, s_iBlink_current);	// ԕ\pLED : _
		s_uiMillis_blinkturn_prev = uiMillis;	// _ŏ̕ێ
	}

	int iIndexButton;

	// {^ꂽǂ
	int g_aiPushed_Button[MAX_BUTTON];
	for( iIndexButton = 0; iIndexButton < COUNT_BUTTON; iIndexButton++ )
	{
		g_aiPushed_Button[iIndexButton] = 0;
		int iState_Button = digitalRead(PIN_BUTTONS[iIndexButton]);
		if( LOW == g_aiState_Button_prev[iIndexButton]
		 && HIGH == iState_Button )
		{	// OFFON
			if( MILLIS_DEBOUNCEDELAY < (uiMillis - g_auiMillis_Button_prev[iIndexButton]) )
			{	// foEXԂo߂ĂȂ΁AȁuOFFONvƂ݂Ȃ
				g_aiPushed_Button[iIndexButton] = 1;
			}
			g_auiMillis_Button_prev[iIndexButton] = uiMillis;
		}
		g_aiState_Button_prev[iIndexButton] = iState_Button;
	}

	// ꂽ{^΁AΉt@CɐM㏑
	for( iIndexButton = 0; iIndexButton < COUNT_BUTTON; iIndexButton++ )
	{
		if( 1 == g_aiPushed_Button[iIndexButton] )
		{
			char szFileName[1024];
			sprintf( szFileName, STRING_FILENAME, iIndexButton );
			if( !SaveHighLowArray( szFileName, g_iCountHighLow, g_ashMicrosHighLow ) )
			{
				myprintf( "Failed    : SaveHighLowArray\n" );
			}
			else
			{
				myprintf( "Succeeded : SaveHighLowArray\n" );
				myprintf( "Finish Storing : Ch=%d\n", iIndexButton );
				g_iStored = 1;
			}
			g_iCountHighLow = 0;
			myprintf( "Change Mode : GeneralMode\n" );
			g_eMode = MODE_GENERAL;	// ʏ탂[hɈڍs
			g_uiMillis_ModeChanged = uiMillis;	// [hύX̕ێ
			return;	// ML̂ŁÃ[v̏IB
		}
	}
	
	// {^ȂԂ^CAEgbo߂ʏ탂[hɖ߂
	if( MILLIS_MODETIMEOUT < (uiMillis - g_uiMillis_ModeChanged) )
	{	// [h^CAEg
		myprintf( "TimeOut     : StoringMode\n" );
		myprintf( "Change Mode : GeneralMode\n" );
		g_eMode = MODE_GENERAL;	// ʏ탂[hɈڍs
		g_uiMillis_ModeChanged = uiMillis;	// [hύX̕ێ
		return;	// [hύX̂ŁÃ[v̏IB
	}
}

// ZbgAbv֐
int setup(void)
{
	// Wiring PiZbgAbvBGPIOsԍgpZbgAbv֐gpB
	return wiringPiSetupGpio();
}

// RM̊wKƋL
// Lꂽꍇ1AmłȂꍇ0ԂB
int learnSignal( 	int iPinIrSensor,
					int iCountButton,
					int* aiPinButton,
					int iPinStateLED )
{
	// o͕ϐ̏
	g_iStored = 0;
	
	// `FbN
	if( 0 >= iCountButton
	 || MAX_BUTTON < iCountButton
	 || NULL == aiPinButton )
	{
		return g_iStored;
	}
	
	// O[oϐւ̐ݒ
	PIN_IRSENSOR 	= iPinIrSensor;	// ԊOZT[̃sԍ
	COUNT_BUTTON	= iCountButton;	// {^̌
	PIN_BUTTONS		= aiPinButton;	// {^̃sԍ
	PIN_STATELED	= iPinStateLED;	// ԕ\pLED̃sԍ

	// O[oϐ̏
	int iIndexButton;
	for( iIndexButton = 0; iIndexButton < COUNT_BUTTON; iIndexButton++ )
	{
		g_aiState_Button_prev[iIndexButton] = LOW;
		g_auiMillis_Button_prev[iIndexButton] = 0;
	}
	
	g_eMode = MODE_LEARNING;	// Ԃ͊wK[hB
	g_uiMillis_ModeChanged = millis();

	// sݒ
	pinMode( PIN_IRSENSOR, INPUT );
	for( iIndexButton = 0; iIndexButton < COUNT_BUTTON; iIndexButton++ )
	{
		pinMode( PIN_BUTTONS[iIndexButton], INPUT );
	}
	pinMode( PIN_STATELED, OUTPUT );

	// o̓s̏
	digitalWrite(PIN_STATELED, LOW);
	
	while(1)
	{
		if( MODE_GENERAL == g_eMode )
		{	// ʏ탂[h
			digitalWrite(PIN_STATELED, LOW);
			return g_iStored;	// IB
		}
		else if( MODE_LEARNING == g_eMode )
		{	// wK[h
			loopSub_Learning();
		}
		else if( MODE_STORING == g_eMode )
		{	// L[h
			loopSub_Storing();
		}
	}
}

// RM̑M
int sendSignal( int iPinIrLED, int iIndexButton )
{
	myprintf( "Send Signal : ButtonID = %d\n", iIndexButton );
	int iCountHighLow = MAX_HIGHLOW;
	short ashMicrosHighLow[MAX_HIGHLOW];
	char szFileName[1024];
	sprintf( szFileName, STRING_FILENAME, iIndexButton );
	if( !LoadHighLowArray( szFileName, &iCountHighLow, ashMicrosHighLow ) )
	{
		myprintf( "Failed    : LoadHighLowArray\n" );
		return 0;
	}
	myprintf( "Succeeded : LoadHighLowArray\n" );
	if( !SendHighLowArray( iPinIrLED, iCountHighLow, ashMicrosHighLow ) )
	{
		myprintf( "Failed    : SendHighLowArray\n" );
		return 0;
	}
	myprintf( "Succeeded : SendHighLowArray\n" );
	return 1;
}
