//
// myremoconWrapper.c
//
// RPythonW[邽߂ɕKvȎ
// 
// Written by Nobuki HIRAMINE
// Last modified : 2016/05/05
//
#include <Python.h>

#include "myremocon.h"

PyObject* py_setup( PyObject* self, PyObject* args )
{
	setup();
	
	return Py_BuildValue( "" );
}

PyObject* py_learn( PyObject* self, PyObject* args )
{
	int iPinIrSensor;
	int iCountButton;
	int aiPinButton[MAX_BUTTON];
	int iPinStateLED;
	
	// ̉
	PyObject* pPyObject;
	if( !PyArg_ParseTuple( args, "iOi", &iPinIrSensor, &pPyObject, &iPinStateLED ) )
	{
		return NULL;
	}
	
	// Xg^Python`C`ɕϊ
	if( !PyList_Check( pPyObject ) )
	{
		return NULL;
	}
	iCountButton = PyList_Size( pPyObject );
	if( MAX_BUTTON < iCountButton )
	{
		return NULL;
	}
	int iIndexButton;
	for( iIndexButton = 0; iIndexButton < iCountButton; iIndexButton++ )
	{
		aiPinButton[iIndexButton] = (int)PyLong_AsLong( PyList_GetItem( pPyObject, iIndexButton ) );
	}	
	
	// ֐Ăяo
	int result = learnSignal(	iPinIrSensor,
								iCountButton,
								aiPinButton,
								iPinStateLED );

	return Py_BuildValue( "i", result );
}

PyObject* py_send( PyObject* self, PyObject* args )
{
	int iPinIrLED;
	int iIndexButton;
	
	// ̉
	if( !PyArg_ParseTuple( args, "ii", &iPinIrLED, &iIndexButton ) )
	{
		return NULL;
	}
	
	// ֐Ăяo
	int result = sendSignal(	iPinIrLED,
								iIndexButton );

	return Py_BuildValue( "i", result );
}

static PyMethodDef pymethoddef[] = {
	{ "setup", py_setup, METH_VARARGS, "" },
	{ "learn", py_learn, METH_VARARGS, "" },
	{ "send", py_send, METH_VARARGS, "" },
	{ NULL },
};

static struct PyModuleDef pymoduledef = {
	PyModuleDef_HEAD_INIT,
	"myremocon",		// W[
	"",
	-1,
	pymethoddef,	// PyMethodDefŒ`ꂽ֐e[ũ|C^
};

// ֐FPyInit_[W[]
PyMODINIT_FUNC PyInit_myremocon( void )
{
	return PyModule_Create( &pymoduledef );
}
